
#include "rmessage.h"
#include <signal.h>

#define SIZE 4096
#define TIMES 10000

void my_handler(int s)
{
	fprintf(stderr, "\n\n############# INTR SIG ##############\n");
	exit(0);
}

main(int argc, char** argv)
{
	int	s, port, res, i, bufsize, data;
	long	start, finish;
	double	delta;
	char	buf[SIZE];
	struct sockaddr_in client, from, to;
	struct sigaction sa;
	fd_set	fds;

	if (argc != 2) {
		fprintf(stderr, "usage: server {port}\n");
		exit(1);
	}

	port  = atoi(argv[1]);

	fprintf(stderr, "Server waiting on port %d.\n", port);

	sa.sa_handler = my_handler;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = 0;
	if (sigaction(SIGINT, &sa, NULL) < 0) {
		perror("sigaction");
		exit(1);
	}

	rm_init();
	s = rm_socket();
	if (s < 0) {
		perror("rm_socket");
		exit(1);
	}

	res = rm_bind(s, port);
	if (res < 0) {
		perror("rm_bind");
		exit(1);
	}

	fprintf(stderr, "Receiving...\n");
	for (i=0; i < TIMES; i++) {
		res = rm_recvfrom(s, buf, SIZE, 0, &from);
		if (res < 0) {
			perror("rm_recvfrom");
			exit(1);
		}
		if (i % 1000 == 0)
			fprintf(stderr, "\t%d\n", i);
	}

	fprintf(stderr, "done.\n");
	sleep(1);
	to = from;

	fprintf(stderr, "Sending...\n");
	for (i=0; i < TIMES; i++) {
		res = rm_sendto(s, buf, SIZE, 0, &to);
		if (res < 0) {
			perror("rm_sendto");
			exit(1);
		}
		if (i % 1000 == 0)
			fprintf(stderr, "\t%d\n", i);
	}
	fprintf(stderr, "done.\n");
	
	rm_close(s);

}

