
#include "mocktcp.h"

#define SIZE 512
#define INTERVAL 3

int	flag = FALSE;

void handler(int s)
{
	flag = TRUE;
}

main(int argc, char** argv)
{
	int	s, port, s2, res, count, bufsize;
	char	buf[SIZE];
	struct sockaddr_in client;
	struct itimerval t;
	struct timeval	val = {INTERVAL, 0};

	if (argc != 2) {
		fprintf(stderr, "usage: server {port}\n");
		exit(1);
	}
	port  = atoi(argv[1]);

	fprintf(stderr, "Server waiting on port %d.\n", port);

	signal(SIGALRM, handler);

	mt_init();

	s = mt_socket();
	if (s < 0) {
		perror("mt_socket");
		exit(1);
	}

	res = mt_bind(s, port);
	if (res < 0) {
		perror("mt_bind");
		exit(1);
	}

loop:

	fprintf(stderr, "Listening...\n");
	res = mt_listen(s);
	if (res < 0) {
		perror("mt_listen");
		exit(1);
	}

	fprintf(stderr, "Accepting...\n");
	s2 = mt_accept(s, &client);
	if (s2 < 0) {
		perror("mt_accept");
		exit(1);
	}

	fprintf(stderr, "New connection established.\n");

	bufsize = 240*1024;
	res = setsockopt(s2, SOL_SOCKET, SO_RCVBUF, &bufsize, sizeof(int));
	if (res < 0) {
		perror("setsockopt");
		exit(1);
	}

	t.it_interval = val;
	t.it_value = val;
	if (setitimer(ITIMER_REAL, &t, NULL) < 0) {
		perror("setitimer");
		exit(1);
	}

	count = 0;
	for (;;) {
		res = mt_read(s2, buf, SIZE);
		if (res < 0) {
			perror("mt_read");
			exit(1);
		}
		count += res;

		if (flag) {
			fprintf(stderr, "%1.3f MB/s\n",
				(count/(1024.0*1024.0))/INTERVAL);
			count = 0;
			flag = FALSE;
		}
		if (res == 0)
			break;
	}

	fprintf(stderr, "************************************************\n");
	fprintf(stderr, "************************************************\n");

	mt_close(s2);
	
	fprintf(stderr, "done.\n");

	/*
	goto loop;
	*/
}


