
#include "hash.h"


void hash_init(hash_table *t, int type)
{
	Tcl_InitHashTable(t, type);
}

void hash_delete(hash_table *t)
{
	Tcl_DeleteHashTable(t);
}

void hash_insert_f(hash_table *t, char* key, void* val)
{
	int		new;
	Tcl_HashEntry	*entry;

	entry = Tcl_CreateHashEntry(t, key, &new);
	if (entry != NULL)
		Tcl_SetHashValue(entry, val);
}

void* hash_find_f(hash_table *t, char* key)
{
	Tcl_HashEntry	*e;

	e = Tcl_FindHashEntry(t, key);
	if (e == NULL)
		return NULL;
	else
		return Tcl_GetHashValue(e);
}

void hash_delete_entry_f(hash_table *t, char* key)
{
	Tcl_HashEntry	*e;

	e = Tcl_FindHashEntry(t, key);
	if (e != NULL)
		Tcl_DeleteHashEntry(e);
}



